import sys
import os
import uuid

from .StairwAINeo4jDriver import NeoDriver
# from kr.StairwAINeo4jDriver import NeoDriver
# from .StairwAINeo4jDriver import NeoDriver

def get_env_var(name, default=None):
    if name in os.environ:
        return os.environ[name]
    else:
        return default


class Driver:
    def __init__(self):
        # load the credentials of the database (normal port 7687)
        bolt_url = get_env_var('NEO4J_URL', 'bolt://localhost:7687')
        user = get_env_var('NEO4J_USER', 'neo4j')
        password = get_env_var('NEO4J_PASSWORD', 's3cr3t')

        # Parameters required for the connection between neo4j server
        self.driver = NeoDriver(bolt_url, user, password)

    def hard_db_reset(self, with_backup=True):
        """
        Hard reset function, this functionality allows the possibility to reset the AMS, e.g. in the case of StairwAI
        ontology update. This function automatically stores all the inserted instances in a backup file, restarts the
        AMS, imports the latest StairwAI ontology available, makes the changes to the swai_ams.json file and finally
        incorporates the instances available in the backup. WARNING: currently, an AMS reset will change all the node
        identifiers!
        :param with_backup: Boolean parameter, if it is set to true a backup of the AMS instances is done before the
        reset, after it the instances are loaded to the AMS again. If it is set to False, the AMS INSTANCES WILL BE
        COMPLETELY AND PERMANENTLY DELETED.
        """
        # create the backup files
        if with_backup:
            self.create_backup()
        # reset function
        self.driver.hard_db_reset()
        # read the backup files and load to the db
        if with_backup:
            self.read_backup()

    def create_backup(self):
        """
        This method creates a StairwAI AMS back-up, with the information extracted from the nodes and relations it
        creates two pickle files where these data are stored. Use 'read_backup()' function in order to store again the
        files information to the database.
        """
        # call the function to create the static files to store instances of the database
        print("Creating back-up files ...")
        self.driver.create_backup()
        print("Back-up files created.")

    def read_backup(self):
        """
        This method read the pickle files with the AMS instances back-up generated by the method create_backup(), and
        load the instances in the AMS. Additionally, in deletes the pickle files.
        """
        # call the function to get all the stored instances stored in the static file
        nodes, relations, non_insta = self.driver.read_backup()
        # get the new id from each of the non instantiable classes and store to a dictionary
        id_dict = {}
        for nn in non_insta:
            if nn['class'] in self.get_aitechniques():
                new_id = self.driver.query_node_by_name_class(nn['name'], 'AI Technique', to_dict=True)
            elif nn['class'] in self.get_business_categories():
                new_id = self.driver.query_node_by_name_class(nn['name'], 'Business categories', to_dict=True)
            else:
                new_id = self.driver.query_node_by_name_class(nn['name'], nn['class'], to_dict=True)
            if new_id is not None:
                id_dict[int(nn['old_id'])] = int(new_id['swai__identifier'])
        # firstly, load nodes into the database
        print("Inserting back-up nodes ...")
        for node in nodes:
            # extract the node metadata
            old_id = node.pop('identifier')
            cls = node.pop('Class')
            # name = node.pop('name')
            node.pop('label')
            # extract the node attributes
            info_node = {
                'swai__'+str(self.driver.properties.loc[self.driver.properties['db_name'] == key].label.values[0]).replace(" ", "_"): value for
                key, value in node.items()}
            # insert the node in the db
            new_node = self.insert_instance(class_type=cls, param_dict=info_node)
            # relate the old_id with the new one
            id_dict[int(old_id)] = int(new_node['swai__identifier'])
        # insert all the relations that exists in the previous version of the database
        print("nodes inserted, start the relation back-up insertions ...")
        for relation in relations:
            if relation['relation'] in ['score', 'scoredIn']:
                # rel = str(self.driver.properties.loc[self.driver.properties['db_name'] == relation['relation']].label.values[0]).replace(" ", "_")
                self.modify_score(start_node_id=id_dict[relation['start_node']], end_node_id=id_dict[relation['end_node']], score=relation['score'])
            else:
                rel = str(self.driver.properties.loc[self.driver.properties['db_name'] == relation['relation']].label.values[0]).replace(" ", "_")
                self.modify_instance(neo_id=id_dict[relation['start_node']], **{rel:id_dict[relation['end_node']]})
        print("Back-up done! :)")

    def var_file_init(self, mod_file=True):
        """
        This method creates from scratch the model data-structures of the AMS using the StairwAI Ontology structure
        imported. Finally, store it in a JSON file.
        :param mod_file: whether the modification in the fixed data structures will be written in the JSON file.
        """
        self.driver.var_file_init(mod_file=mod_file)

    # GETTERS #
    def get_classes(self, only_labels=False):
        """
        Getter of the ontology defined classes.
        :param only_labels: specifies whether the user only wants the instantiable class labels (True) or if the user
        wants the class definitions (False).
        :return: a list of the available classes.
        """
        return self.driver.get_instantiable_classes(only_instantiable=False, only_labels=only_labels)

    def get_instantiable_classes(self, only_labels=False):
        """
        Getter of the ontology instantiable classes with its definitions.
        :param only_labels: specifies whether the user only wants the instantiable class labels (True) or if the user
        wants the class definitions (False).
        :return: a list, or dictionary, of the available instantiable classes
        """
        return self.driver.get_instantiable_classes(only_instantiable=True, only_labels=only_labels)

    def get_attributes(self, with_conditions: bool):
        """
        Getter of the ontology defined attributes.
        :param with_conditions: whether the method must return the domain of each property.
        :return: If with_conditions is True, a pandas data frame with the properties and its domain. Otherwise, it will
        return the list of available attributes.
        """
        return self.driver.get_attributes(with_conditions)

    def get_relations(self, with_conditions: bool):
        """
        Getter of the ontology defined relations.
        :param with_conditions: whether the method must return the domain/range of relation.
        :return: If with_conditions is True, a pandas' data frame with the relations and its domain/range. Otherwise, it
        will return the list of available relations.
        """
        return self.driver.get_relations(with_conditions)

    def get_node_data_to_dict(self, node):
        """
        This query returns the node data as a dictionary.
        :param node: py2neo.Node instance.
        :return: Node data as a dictionary, if node = None, returns None.
        """
        return self.driver.get_node_data_to_dict(node)

    def get_class_properties(self, class_type: str):
        """
        This method returns a dictionary with the properties, and its definitions, of a specific type of class.
        :param class_type: the name (label) of the class from which to extract the properties.
        :return: A dictionary with the properties available for a specific class and its requirements.
        """
        return self.driver.get_class_properties(class_type)

    def get_business_categories(self, with_details=False):
        """
        Available business categories' getter.
        :param with_details: if True it returns the descriptions, additionally to the labels of the business
        categories as a dictionary.
        :return: List of the available Business category instances.
        """
        if with_details:
            details = self.driver.get_classes(with_descriptions=with_details)
            return {technique:details[technique] for technique in self.driver.get_instances_by_class('BusinessCategories')
                    if details[technique][0] is not None}
        return self.driver.get_instances_by_class('BusinessCategories')

    def get_aitechniques(self, with_details=False):
        """
        Available AI Techniques' getter.
        :param with_details: if True it returns the descriptions, additionally to the labels of the business
        categories as a dictionary.
        :return: List of the available AI Technique instances.
        """
        label_list = self.driver.get_instances_by_class('AITechnique')
        if with_details:
            label_details = {}
            for label in label_list:
                details = self.driver.get_class_id_desc(label)
                if details[0] is not None and details[1] is not None:
                    label_details[label] = details
            return label_details
        return label_list

    def get_aiexperts(self, uuid_identifier=None, swai_id_only=False):
        # Prepare a result data structure
        res = None

        # Retrieve the required data
        if uuid_identifier is None:
            # In this care, retrive the full expert list
            res = self.driver.query_instances_by_class('AI expert',
                    to_dict=not swai_id_only)
            # If required, select just the IDs
            if swai_id_only:
                res = [n['swai__identifier'] for n in res]
        else:
            # In this case, retrive a single node
            res = self.driver.query_node_by_uuid(uuid_identifier, 'AI expert',
                    to_dict=not swai_id_only)
            # If required, select just the IDs
            if swai_id_only:
                res = res['swai__identifier']

        # Return results
        return res


    def get_countries(self):
        """
        Available countries' getter.
        :return: List of the available Country instances.
        """
        return self.driver.get_instances_by_class('Country')

    def get_organisation_types(self):
        """
        Available organisation types' getter.
        :return: List of the available Organisation type instances.
        """
        return self.driver.get_instances_by_class('OrganisationType')

    def get_containers(self):
        """
        Available containers' getter.
        :return: List of the available Container instances.
        """
        return self.driver.get_instances_by_class('Container')

    def get_distributions(self):
        """
        Available distributions' getter.
        :return: List of the available Distribution instances.
        """
        return self.driver.get_instances_by_class('Distribution')

    def get_paces(self):
        """
        Available paces' getter.
        :return: List of the available Pace instances.
        """
        return self.driver.get_instances_by_class('Pace')

    def get_languages(self, with_code:bool =False):
        """
        Available languages' getter.
        :param with_code: if true, apart from language label it retrieve the language code
        :return: List of the available Language instances.
        """
        return self.driver.get_instances_by_class('Language', with_description=with_code)

    def get_education_levels(self):
        """
        Available education levels' getter.
        :return: List of the available Education level instances.
        """
        return self.driver.get_instances_by_class('EducationLevel')

    def get_education_types(self):
        """
        Available education types' getter.
        :return: List of the available Education type instances.
        """
        return self.driver.get_instances_by_class('EducationType')

    def get_skills(self):
        """
        Available skills' getter.
        :return: List of the available Skill instances.
        """
        return self.driver.get_instances_by_class('Skill')

    # INSTANCE MODIFICATORS #
    def insert_instance(self, class_type, param_dict:dict):
        """
        This function allows the insertion of new instances into the database. To check the set of available
        instantiable classes, please call get_instantiable_classes() function. Additionally, to know the available
        relations and attributes for the instances of a specific class, call query_get_class_properties(class_type)
        function.
        :param class_type: The class of the inserted instance.
        :param param_dict: the instance specific dictionary (relations or attributes) that are going to be modified in
        the AMS. This dictionary would only accept the specific relations/attributes to the class of the node, to check
        it, call query_get_class_properties(class_type) where you could find the relations/attributes for the class, a
        description of them and their range.
        :return: the dictionary with the data of the node inserted.
        """
        # check that swai__name exist, mandatory field
        if 'swai__name' not in param_dict.keys():
            raise Exception("'swai__name' field in param_dict is mandatory to insert a new instance")
        # insert the new instance into the database
        node = self.driver.insert_node(param_dict['swai__name'], class_type)
        if node.identity == 0:
            self.driver.delete_node(neo_id=node.identity)
            return self.insert_instance(class_type, param_dict)
        # specify the identifiers for the new instances
        param_dict['swai__identifier'] = node.identity
        # specify the instances identifier
        df_row = self.driver.properties.loc[self.driver.properties["label"] == 'uuid identifier']
        if class_type in df_row["domain"].values[0]:
            param_dict['swai__uuid_identifier'] = str(uuid.uuid1())
        param_dict['instr'] = True
        # store the parameters
        return self.modify_instance(node.identity, param_dict)

    def delete_instance(self, neo_id: int):
        """
        This function deletes the instance specified by its identifier.
        :param neo_id: identifier of the instance that has to be deleted.
        """
        self.driver.delete_node(neo_id)

    def modify_instance(self, neo_id: int, param_dict:dict, delete_property: bool = False):
        """
        This function allows the modification of any instance node in the database. To check the available instantiable
        classes, call get_instantiable_classes() function. Additionally, to check the available relations and attributes
        for the instances of a specific class, call query_get_class_properties(class_type) function.
        :param neo_id: identifier of the instance which is to be modified.
        :param param_dict: the instance specific dictionary (relations or attributes) that are going to be modified in
        the AMS. This dictionary would only accept the specific relations/attributes to the class of the node, to check
        it, call query_get_class_properties(class_type) where you could find the relations/attributes for the class, a
        description of them and their range.
        :param delete_property: whether the attribute or a relation is to be deleted (True), or inserted (False).
        :return: the dictionary with the data of the node modified.
        """
        # check if this function was called from insertion
        if 'instr' in param_dict.keys():
            instr = param_dict.pop('instr')
        else:
            instr = False
            if 'swai__identifier' in param_dict.keys():
                raise Exception("swai__identifier parameter is automatically generated and cannot be modified")

        # extract all the possible relation for the class of the node
        clas = self.driver.class_4_instance(neo_id)
        rel_all = self.get_class_properties(clas)
        range_all =[ a['property'] for a in rel_all['Relations']['properties'] + rel_all['Attributes']['properties']]
        # check if the dictionary has wrong parameters
        error_msg = 'There are some relations and/or attributes that specified as a parameter that are not associated to the class, are:'
        error_ck = False
        for k in param_dict.keys():
            if k not in range_all:
                error_ck = True
                error_msg += ' '+k+','
        if error_ck:
            # if bad instance insertion, delete the node
            if instr and not delete_property:
                self.delete_instance(neo_id=neo_id)
            raise Exception(error_msg)
        #insert new parameters
        for key, value in param_dict.items():
            if value is None:
                continue
            prop = key.split('__')[1].replace("_", " ")
            df_row = self.driver.properties.loc[self.driver.properties["label"] == prop]
            # if it is an ObjectProperty (Relations)
            if df_row["type"].values[0] == "ObjectProperty":
                # if score insertion
                if prop == 'scored in':
                    if type(value) is not dict:
                        raise Exception(
                            "The scores should be inserted as a dictionary with  key=AI technique label and score=score_value")
                    for aitec in value.keys():
                        val_id = self.driver.get_id_from_label_relation(aitec, prop)
                        if val_id is None:
                            raise Exception(
                                "The relation: " + str(key) + " cannot be inserted because the instance: " + str(
                                    aitec) + " does not exist.")
                        self.modify_score(neo_id, val_id, value[aitec], delete_property)
                    continue
                # if is a single relation, create a list of one element (standardize the values to lists)
                if type(value) is not list:
                    value = [value]
                # for each relation node insert the new property
                for val in value:
                    try:
                        # extract the id of the end node in the relation
                        val_id = self.driver.get_id_from_label_relation(val, prop)
                        if val_id is None:
                            raise Exception("The relation: "+str(key)+" cannot be inserted because the instance: "+str(val)+ " does not exist as a instance of a class in the range of the relation.")
                        # if the modification is a deletion
                        if delete_property:
                            self.driver.delete_property(neo_id, prop, end_node_id=val_id, error_if_not_existing=False)
                        # if the modification is an insertion
                        else:
                            # if a relation already exists in the database
                            if self.query_if_relation_exists(neo_id, prop, val_id):
                                print("The relation " + prop + " between nodes: " + str(neo_id) + " (id) and " + str(
                                    val) + " already exists, modification cancelled.")
                            else:
                                self.driver.insert_property(neo_id, prop, end_node_id=val_id)
                    except Exception:
                        # if bad insertion parameters, insertion cancelled and delete trash node
                        if instr and not delete_property:
                            self.delete_instance(neo_id=neo_id)
                        raise sys.exc_info()[1]
            # if it is a DataTypeProperty (Attributes)
            else:
                try:
                    # if the modification is a deletion
                    if delete_property:
                        self.driver.delete_property(neo_id, prop, error_if_not_existing=False)
                    # if the modification is an insertion
                    else:
                        self.driver.insert_property(neo_id, prop, value=value)
                except Exception:
                    # if bad insertion parameters, insertion cancelled and delete trash node
                    if instr and not delete_property:
                        self.delete_instance(neo_id=neo_id)
                    raise sys.exc_info()[1]
        return self.driver.query_node_by_id(neo_id, to_dict=True)

    def modify_score(self, start_node_id: int, end_node_id: int, score: float = None, delete_property: bool = False):
        """
        Insert, or delete, a score in the AMS.
        :param start_node_id: Identifier of the instance (node) from which the new score is to be set.
        :param score: The value of the (float number).
        :param end_node_id: identifier of the node to connect.
        :param delete_property: whether to delete attributes or relations (True), or to insert new ones (False).
        """
        # if starting instance is a AITechnique relation is 'score', if else 'scored in'
        relation = 'score' if self.query_class_by_id(start_node_id) in self.get_aitechniques() else 'scored in'

        if score is None and not delete_property:
            raise Exception("You should specify the score to insert.")

        # if already exists a score, then delete the original to be able to insert the new one below
        if not delete_property and self.driver.query_if_relation_exists(start_node_id, relation, end_node_id):
            self.driver.delete_property(neo_id=start_node_id, relation=relation, end_node_id=end_node_id)
            # print("Score substituted")
        try:
            # if the modification is a deletion
            if delete_property:
                self.driver.delete_property(neo_id=start_node_id, relation=relation, end_node_id=end_node_id)
            # if the modification is an insertion
            else:
                self.driver.insert_property(neo_id=start_node_id, relation=relation, end_node_id=end_node_id, value=score)
        except Exception:
            raise sys.exc_info()[1]

    def score_list_modifier(self, score_list:list):
        """
        Insert a list of scores in the AMS using a list of dictionaries.
        :param score_list: list of dictionaries, where each dictionary is a score insertion, it requires the fields of
        'start_node_id' (with the ID of the relation starting instance), 'end_node_id' (with the ID of the relation
        ending instance) and 'score' (field that specify the score value).
        """
        for score_dict in score_list:
            self.modify_score(score_dict['start_node_id'],score_dict['end_node_id'], score_dict['score'])


    # QUERIES #
    def free_query(self, query: str):
        """
        This query allows a personalized query construction.
        :param query: string with the Cypher code command (query) that is going to be used.
        :return: The result of the query, without post-processing.
        """
        return self.driver.free_query(query)

    def query_exist_instance(self, neo_id: int):
        """
        This query returns true if a specific instance exists in the database.
        :param neo_id: ID of the instance searched.
        :return: True if the instance identified by id exists in the AMS, False otherwise.
        """
        return self.driver.query_exist_instance(neo_id)

    def query_if_relation_exists(self, start_node_id: int, relation:str, end_node_id:int):
        """
        This query returns True if a specific relation exists in the AMS, or returns false if it does not exist
        :param start_node_id: identifier of the starting instance in the relation (all the relations in the AMS are
        directed).
        :param relation: relation to be searched.
        :param end_node_id: identifier of the ending instance in the relation (all the relations in the AMS are
        directed).
        :return: A boolean with the result of the query.
        """
        return self.driver.query_if_relation_exists(start_node_id=start_node_id, relation=relation, end_node_id=end_node_id)

    # def query_if_relation_exists(self, start_node_id: int, relation:str, end_node_id:int):
    #     """
    #     This query returns True if a specific relation exists in the AMS, or returns false if it does not exist
    #     :param start_node_id: identifier of the starting instance in the relation (all the relations in the AMS are
    #     directed).
    #     :param relation: relation to be searched.
    #     :param end_node_id: identifier of the ending instance in the relation (all the relations in the AMS are
    #     directed).
    #     :return: A boolean with the result of the query.
    #     """
    #     return self.query_if_relation_exists(start_node_id=start_node_id, relation=relation, end_node_id=end_node_id)

    def query_node_by_name_class(self, name: str, ont_class: str, to_dict=False):
        """
        This query returns an instance, if it exists, based on its name and the class.
        :param name: name of the instance searched.
        :param ont_class: class of the instance searched.
        :param to_dict: whether the result must be returned as a dictionary (True) or apy2neo.Node instance (False).
        :return: Instance data or instance node, if it exists.
        """
        return self.driver.query_node_by_name_class(db_name=name, db_class=ont_class, to_dict=to_dict)

    def query_node_by_name(self, name: str, to_dict=False):
        """
        This query returns an instance, if it exists, given its name. WARNING: DO NOT USE UNLESS IT IS ABSOLUTELY
        NECESSARY, very slow function with exponential time cost. Alternatively, use query_node_by_name_class that uses
        the instance class also.
        :param name: name of the instance searched.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :return: Instance data or instance node, if it exists.
        """
        return self.driver.query_node_by_name(name=name, to_dict=to_dict)

    def query_node_by_id(self, neo_id: int, to_dict=False):
        """
        This query returns the node, if it exists, given its identifier.
        :param neo_id: id of the instance searched.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :return: Instance data or instance node, if it exists.
        """
        return self.driver.query_node_by_id(neo_id, to_dict)

    def query_node_by_uuid(self, uuid_db: str, ont_class:str, to_dict: bool = False):
        """
        This query returns an instance, if it exists, based on its uuid and the class. Only AI Asset subclasses have
        uuid.
        :param uuid_db: UUID identifier of the instance searched.
        :param ont_class: class of the instance searched.
        :param to_dict: whether the result must be returned as a dictionary (True) or apy2neo.Node instance (False).
        :return: Instance data or instance node, if it exists.
        """
        print(self.driver.inference_subclasses(['AI Asset'], self.driver.class_owl))
        if ont_class not in self.driver.inference_subclasses(['AI Asset'], self.driver.class_owl):
            raise Exception("{0} is not an instantiable class, uuid are only available for AI Asset subclasses".format(ont_class))
        return self.driver.query_node_by_uuid(uuid=uuid_db, db_class=ont_class, to_dict=to_dict)


    def query_instances_by_class(self, class_label, with_inference:bool, to_dict=False):
        """
        This query returns all the instances of a specific class.
        :param class_label: class name.
        :param with_inference: in the case of True value in this parameter, the query will retrieve the instances of the
        class specified as a parameter and all the instances of its subclasses also.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :return: List of the instance data or instance nodes, if they exist.
        """
        return self.driver.query_instances_by_class(class_label, with_inference=with_inference, to_dict=to_dict)

    def query_class_by_id(self, neo_id: int):
        """
        This query returns the class label of an instance, given an identifier.
        :param neo_id: id of the instance searched.
        :return: The class label of the instance with the id.
        """
        return self.driver.class_4_instance(neo_id=neo_id)

    def query_related_nodes_by_relation(self, neo_id: int, relation: str, to_dict=False):
        """
        This query returns the data of the instances related to the given identifier and relation.
        :param neo_id: id of the instance searched.
        :param relation: relation to be searched.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :return: List of the instance data, or instance nodes, if they exist.
        """
        return self.driver.query_related_nodes_by_relation(neo_id, relation, to_dict)

    def query_get_assets_by_tag(self, categories: list, limit: int, inference_cat: bool = False, to_dict: bool = False):
        """
        This query returns a list of AI Artifacts that belongs to a specific AI Technique.
        :param categories: list of AI Techniques from which to retrieve the instances.
        :param limit: limit of nodes to be retrieved by the query.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :param inference_cat: whether to infer the AI Techniques subcategories of the ones in categories parameter.
        :return: A list of dictionaries where, for each category searched, a dictionary is retrieved with the artifact
        and the category that belongs to.
        """
        return self.driver.query_get_assets_by_tag(categories, limit, inference_cat, to_dict)

    def query_get_experts_by_tag(self, categories: list, limit: int, inference_cat: bool = False, to_dict: bool = False):
        """
        This query returns a list of AI Experts that belongs to a specific AI Technique.
        :param categories: list of AI Techniques from which to retrieve the instances.
        :param limit: limit of nodes to be retrieved by the query.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :param inference_cat: whether to infer the AI Techniques subcategories of the ones in categories parameter.
        :return: A list of dictionaries where, for each category searched, a dictionary is retrieved with the expert
        and the category that belongs to.
        """
        return self.driver.query_get_experts_by_tag(categories, limit, inference_cat, to_dict)

    def query_topk_assets(self, category: str, k: int, to_dict: bool = False):
        """
        This query returns an ordered asset list with, at most, K elements based on the scored assets in AI Technique.
        :param category: AI Technique from which the assets will be retrieved.
        :param k: the maximum number of elements retrieved.
        :param to_dict: whether to return the node data as a dictionary (True) or a py2neo.Node instance (False).
        :return: An ordered list of assets (dictionaries{score, instance}).
        """
        return self.driver.query_topk_assets(category, k, to_dict)
